/*+------------------------------------------------------------------+
 | FileName: KG - Trapping Mode V2.1.mq4
 | Author: Copyright  2007, kang_gun
 | Version : 02.1
 | 
 +------------------------------------------------------------------+*/
#property copyright "Copyright  2007, kang_gun"
#property link      "http://www.freeknowledge.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkSlateGray
#property indicator_color2 DarkSlateGray
#property indicator_color3 DarkSlateGray
#property indicator_color4 DarkSlateGray
#property indicator_color5 DarkSlateGray
#property indicator_color6 DarkSlateGray
#property indicator_color7 DarkSlateGray
#property indicator_color8 DarkSlateGray
//---- input parameters

//---- buffers

double H1Buffer[];
double H4Buffer[];
double H3Buffer[];
double H2Buffer[];
double L2Buffer[];
double L3Buffer[];
double L4Buffer[];
double L1Buffer[];
string sL1="L1", sL2="L2" ,sH1="H1", sH2="H2";
string sL3="L3", sH3="H3", sL4="L4", sH4="H4";
int fontsize=8;
double L2, L3, L4, H2, H3, H4, H1, L1;
double x;
extern int DAYS=1;
int Daily_Range_Average;
extern int Start_Time=0;

double O, LL1, LL2, LL3, LL4, LH1, LH2, LH3, LH4;
double F1, F2, F3, F4;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("L1");
   ObjectDelete("H1");
   ObjectDelete("L2");
   ObjectDelete("H2");
   ObjectDelete("L3");
   ObjectDelete("H3");
   ObjectDelete("L4");
   ObjectDelete("H4");   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 0);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(0, L1Buffer);
   SetIndexBuffer(1, L2Buffer);
   SetIndexBuffer(2, H2Buffer);
   SetIndexBuffer(3, L3Buffer);
   SetIndexBuffer(4, H3Buffer);
   SetIndexBuffer(5, L4Buffer);
   SetIndexBuffer(6, H4Buffer);
   SetIndexBuffer(7, H1Buffer);

//---- name for DataWindow and indicator subwindow label
   short_name="KG-Trapping Mode V2.1";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
   
   double daily_high[20];
   double daily_low[20];
   double yesterday_close;
   double phigh,plow;
   int p=1;

   ArrayResize(daily_high,DAYS);
   ArrayResize(daily_low,DAYS);
   ArrayInitialize(daily_high,0);
   ArrayInitialize(daily_low,0);

   ArrayCopySeries(daily_low, MODE_LOW, Symbol(), PERIOD_D1);
   ArrayCopySeries(daily_high, MODE_HIGH, Symbol(), PERIOD_D1);
   
   plow=daily_low[1];
   phigh=daily_high[1];

   for(p=1;p<DAYS;p++)
   {
      if(plow>daily_low[p])
      {
         plow =daily_low[p];
      }
   }

   for(p=1;p<DAYS;p++)
   {
      if(phigh<daily_high[p])
      {
         phigh =daily_high[p];
      }
   }

//---- indicator calculation
if (counted_bars==0)
{
   x=Period();
   if (x>240) return(-1);
   ObjectCreate("L2", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L2", "                 Sell TP1",fontsize,"Arial", White);
   ObjectCreate("H2", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H2", "                 Buy TP1",fontsize,"Arial", White);
   ObjectCreate("L3", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L3", "                 Sell TP2",fontsize,"Arial", White);
   ObjectCreate("H3", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H3", "                 Buy TP2",fontsize,"Arial", White);
   ObjectCreate("L4", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L4", "                 Sell TP3",fontsize,"Arial", White);
   ObjectCreate("H4", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H4", "                 Buy TP3",fontsize,"Arial", White);
   ObjectCreate("L1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L1", "               OP Sell",fontsize,"Arial", White);
   ObjectCreate("H1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H1", "               OP Buy",fontsize,"Arial", White);
}
   if(counted_bars<0) return(-1);
      limit=(Bars-counted_bars)-1;



for (i=limit; i>=0;i--)
{ 

if (TimeDay(Time[i])!=TimeDay(Time[i+1]))
   { 
   
   Daily_Range_Average=(phigh-plow)/Point;
   
   F1=(Daily_Range_Average*0.382*Point);
   F2=(Daily_Range_Average*0.764*Point);
   F3=(Daily_Range_Average*1.146*Point);
   F4=(Daily_Range_Average*1.528*Point);

	H1=F1 + Open[i-Start_Time];
	H2=F2 + Open[i-Start_Time];
	H3=F3 + Open[i-Start_Time];
	H4=F4 + Open[i-Start_Time];
	L1=Open[i-Start_Time] - F1;
	L2=Open[i-Start_Time] - F2;
	L3=Open[i-Start_Time] - F3;
	L4=Open[i-Start_Time] - F4;   
	
   //O=Open[i-Start_Time];
	
   ObjectMove("L1", 0, Time[i-Start_Time], L1);
   ObjectMove("H1", 0, Time[i-Start_Time], H1);
   ObjectMove("L2", 0, Time[i-Start_Time], L2);
   ObjectMove("H2", 0, Time[i-Start_Time], H2);
   ObjectMove("L3", 0, Time[i-Start_Time], L3);
   ObjectMove("H3", 0, Time[i-Start_Time], H3);
   ObjectMove("L4", 0, Time[i-Start_Time], L4);
   ObjectMove("H4", 0, Time[i-Start_Time], H4);

   }
    
    L1Buffer[i-Start_Time]=L1;
    L2Buffer[i-Start_Time]=L2;
    L3Buffer[i-Start_Time]=L3;
    L4Buffer[i-Start_Time]=L4;
    H1Buffer[i-Start_Time]=H1;
    H2Buffer[i-Start_Time]=H2;
    H3Buffer[i-Start_Time]=H3;
    H4Buffer[i-Start_Time]=H4;

}

//----
   Comment ("                                                                    ","\n",
            "-----------------------------------------------------------------------------------------------------","\n",
            "       KG_Trapping Mode V2.1 --> Start_Time input is value 0 to 23","\n",
            "-----------------------------------------------------------------------------------------------------","\n",
            "                                                                    ","\n",
            "Buy Stop: ",H1, "   SL: ", L1, "   TP1: ",H2, "   TP2: ",H3, "   TP3: ",H4,"\n",
            "Sell  Stop: ",L1, "   SL: ", H1, "   TP1: ",L2, "   TP2: ",L3, "   TP3: ",L4
            );
   

   return(0);
  }
//+------------------------------------------------------------------+